package fun.bb1.spigot.fly;

import java.util.List;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.PluginCommand;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import fun.bb1.spigot.fly.config.Config;

final class FlyCommand implements TabExecutor {
	
	private @NotNull final JavaPlugin plugin;
	private @NotNull final Config config;
	
	FlyCommand(@NotNull final JavaPlugin plugin, @NotNull final Config config) {
		this.plugin = plugin;
		this.config = config;
		final PluginCommand command = this.plugin.getCommand("fly");
		command.setExecutor(this);
		command.setTabCompleter(this);
	}
	
	@Override
	public final List<String> onTabComplete(CommandSender sender, Command command, String alias, String[] arguments) {
		if (sender.hasPermission("fly.toggle.other")) return Bukkit.getOnlinePlayers().stream().map(Player::getName).toList();
		return List.of();
	}

	@Override
	public final boolean onCommand(CommandSender sender, Command command, String alias, String[] arguments) {
		if (arguments.length != 0) {
			if (!sender.hasPermission("fly.toggle.other")) {
				this.config.sendToggleOtherFailPermissionMessage(sender);
				return true;
			}
			for (final String playerName : arguments) {
				@Nullable final Player player = Bukkit.getPlayer(playerName);
				if (player == null) {
					this.config.sendToggleOtherFailPlayerMessage(sender);
					continue;
				}
				player.setAllowFlight(!player.getAllowFlight());
				player.setFlying(player.getAllowFlight());
				this.config.sendToggleMessage(player);
				this.config.sendToggleOtherMessage(sender, player);
			}
			return true;
		}
		if (!(sender instanceof Player player)) {
			sender.sendMessage("Cannot toggle flight for non-player");
			return true;
		}
		player.setAllowFlight(!player.getAllowFlight());
		player.setFlying(player.getAllowFlight());
		this.config.sendToggleMessage(player);
		return true;
	}

}
